unit Unit1;

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, Forms, Controls, Graphics, Dialogs, StdCtrls;

type

  TCheckbox = class(StdCtrls.TCheckbox)
  public
    constructor Create(AOwner: TComponent); override;
  end;

  TLabel = class(StdCtrls.TLabel)
  public
    constructor Create(AOwner: TComponent); override;
  end;

  { TForm1 }

  TForm1 = class(TForm)
    CheckBox1: TCheckBox;
    CheckBox2: TCheckBox;
    Label1: TLabel;
    Label2: TLabel;
    procedure CheckBox1Click(Sender: TObject);
    Procedure CheckBox2Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
  private

  protected
    procedure Loaded; override;

  public
    constructor Create(AOwner: TComponent); override;

  end;

var
  Form1: TForm1;

implementation

{$R *.lfm}

var
  FLoaded: String = '';

constructor TCheckbox.Create(AOwner: TComponent);
begin
  WriteLn('Creating Checkbox');
  inherited;
  WriteLn('Checkbox created');
end;

constructor TLabel.Create(AOwner: TComponent);
begin
  WriteLn('Creating Label');
  inherited;
  WriteLn('Label created');
end;

constructor TForm1.Create(AOwner: TComponent);
begin
  WriteLn('Creating Form');
  inherited;
  WriteLn('Form created');
end;

procedure TForm1.CheckBox1Click(Sender: TObject);
var
  s: String;
begin
  if csLoading in ComponentState  then s :='loading' else s := '';
  WriteLn('Checkbox.OnClick', ' ', s, ' ', FLoaded);
  Label1.caption := Checkbox1.Checked.ToString;
end;

Procedure TForm1.CheckBox2Click(Sender: TObject);
var
  s: String;
begin
  if csLoading in ComponentState  then s :='loading' else s := '';
  WriteLn('Checkbox2.OnClick', ' ', s, ' ', FLoaded);
  Label2.caption := Checkbox2.Checked.ToString;
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
  WriteLn('Form.OnCreate');
end;

procedure TForm1.Loaded;
begin
  inherited;
  WriteLn('Loaded complete');
end;

end.

